#!/usr/bin/perl -w

my ($expr,$size);
my ($big,$numb,$x)=(1,1,"");
my %found;

my ($starttime,$trynr,$waitsec);

system("mkdir /tmp/pftpl-$$");
chdir "/tmp/pftpl-$$" || exit 1;

sub finish($) {
	chdir "/";
	system("rm -rf /tmp/pftpl-$$");
	exit $_[0];
}

if (not defined $ARGV[1]) {
	print "Usage: $0 filename ftpdir\n";
	finish 1;
}

$expr="|".$ARGV[0]."|";
$_="X";
while ($expr ne $_) {
	$_=$expr;
	$expr=~s/[^a-zA-Z]+/\|/g;
	$expr=~s/\|(.{0,2}|pre|src|bin|netkit|[Ll]inux)\|/\|/g;
	$expr=~s/\|(tar|tgz|txt|BSD|beta|alpha|tools|diff|orig)\|/\|/g;
}
$expr=~s/\|(.*)\|/$1/g;

$expr="$1"            if $ARGV[0]=~/^(gnome-\w+)/;
$expr="$1"            if $ARGV[0]=~/^(X\d+)/;
$expr="$1-"           if $ARGV[0]=~/^(file|patch|xv|gv|a2ps|ee|at|qt|gd)-/;
$expr="netkit-$1"     if $ARGV[0]=~/^netkit-(\w+)/;
$expr="$1-utils"      if $ARGV[0]=~/^(id|sh)-utils/;
$expr="man-pages"     if $ARGV[0]=~/^man-pages/;
$expr="mail.*local"   if $ARGV[0]=~/^mail.local/;
$expr="$1-tools"      if $ARGV[0]=~/(net|console)-tools/;
$expr="^$1"           if $ARGV[0]=~/^(ld.so|bin86|bc|ed|m4|mc|tk)[^a-zA-Z]/;
$expr="^$1"           if $ARGV[0]=~/^(linux|tar|py)[^a-zA-Z]/;
$expr="^glibc-\\d"    if $ARGV[0]=~/^glibc-\d/;
$expr="^glibc-$1"     if $ARGV[0]=~/^glibc-(\w+)/;
$expr="teTeX-$1"      if $ARGV[0]=~/^teTeX-(lib|src)/;

$ARGV[1]=~s/^\!//;

if ($ARGV[0] !~ /gcc-2.7.2.2.tar.gz/) {
  $ARGV[1]=~s,/([^/]+)/$,/,  if $ARGV[0]=~/gcc-.*\.tar|gimp|cvs|bind|ghostscript/;
  $_=$1;  $expr=".|$_"       if $ARGV[0]=~/gcc-.*\.tar|gimp|bind|ghostscript/;
}

if ($ARGV[0]=~/^X\d+src-(\d+)/) {
	finish 1 if $1 != 1;
	$ARGV[1]=~s,/([^/]+)/[^/]+/$,/,;
	$expr='\d';
	$ARGV[0]="XFree86-$1";
}

print STDERR "$ARGV[1] $ARGV[0]\n";

print "\n  $ARGV[0] ($expr) $ARGV[1]:\n\n";

if ($expr eq '' or $expr eq '|') {
	print "No expression ...\n";
	finish 1;
}

sleep 15;

if ($ARGV[1]=~/ftp:\/\//) {
	system "rm -f .listing*";
	$trynr=0; print STDERR " FTP-$trynr";
	$0="FTP-$trynr 0 $ARGV[1]$ARGV[0]";
	$_="wget -nr -O /dev/null $ARGV[1] >> output.txt 2>&1 ; " .
	   "[ -s .listing ] || rm -f .listing";
	system $_; $starttime=time();
	while ( (not -f ".listing") && ((time()-$starttime) < 600) && $trynr<5) {
		$waitsec=15*$trynr; $waitsec=60 if $waitsec > 60; $trynr++;
		system("sleep $waitsec"); print STDERR " FTP-$trynr"; system $_;
		$0="FTP-$trynr ".(time()-$starttime)." $ARGV[1] $ARGV[0]";
	}
	if (not open(F,"<.listing")) {
		print "Command failed: $_\n";
	} else {
		while (<F>) {
			s/->.*$//;
			s/.*\s+(\S+)\s*$/$1/;
			next unless /$expr/;
			$x=$_; s/(\d+)/sprintf("%010d",$1)/ge;
			$found{$_}="$x";
			$big=length $x if length $x > $big;
		}
		close F;
	}
} elsif ($ARGV[1]=~/http:\/\//) {
	system "rm -f .listing*";
	$trynr=0; print STDERR " HTTP-$trynr";
	$0="HTTP-$trynr 0 $ARGV[1]$ARGV[0]";
	$_="wget -nr -O .listing $ARGV[1] >> output.txt 2>&1 ; " .
	   "tr ' ' '\\n' < .listing > .listing2 ; " .
	   "[ -s .listing2 ] || rm -f .listing2";
	system $_; $starttime=time();
	while ( (not -f ".listing2") && ((time()-$starttime) < 600) && $trynr<5) {
		$waitsec=15*$trynr; $waitsec=60 if $waitsec > 60; $trynr++;
		system("sleep $waitsec"); print STDERR " HTTP-$trynr"; system $_;
		$0="HTTP-$trynr ".(time()-$starttime)." $ARGV[1] $ARGV[0]";
	}
	if (not open(F,"<.listing2")) {
		print "Command failed: $_\n";
	} else {
		$ARGV[1]=~s/[^\/]*$//;
		while (<F>) {
			next unless /HREF="?([^">\s]*)[">\s]/i;
			$_=$1; s/$ARGV[1]//g;
			next unless /$expr/;
			s/^.*\/(.)/$1/;
			$x=$_; s/(\d+)/sprintf("%010d",$1)/ge;
			$found{$_}="$x";
			$big=length $x if length $x > $big;
		}
		close F;
	}
} else {
	print "Protocoll not supported ($ARGV[1]).\n";
	finish 1;
}

$big=30 if $big > 30;
foreach (sort keys %found) {
	$numb++;
	if ($numb < 75/($big+2)) {
		printf("%-*.*s  ",$big,$big,$found{$_});
	} else {
		print $found{$_},"\n";  $numb=1;
	}
	
}
print "\n" if $numb != 1;

finish 0;
